declare const stringParamTypeMap: {
    bool: ParamType;
    int: ParamType;
    float: ParamType;
    string: ParamType;
    entity: ParamType;
    actor: ParamType;
    player: ParamType;
    xyz: ParamType;
    pos: ParamType;
    vec: ParamType;
    text: ParamType;
    message: ParamType;
    json: ParamType;
    item: ParamType;
    block: ParamType;
    effect: ParamType;
    enum: ParamType;
    softEnum: ParamType;
    entities: ParamType;
    actor_type: ParamType;
    command: ParamType;
    selector: ParamType;
};
type Handler<T = any> = (cmd: Command, origin: CommandOrigin, output: CommandOutput, result: T) => void;
type CommandExpr = string | keyof typeof stringParamTypeMap | `${keyof typeof stringParamTypeMap}?`;
export declare class Registry {
    private _cmd;
    private _tokenListCollection;
    private _handlerCollection;
    constructor(cmd: Command);
    private getCollection;
    register(cmd: CommandExpr, handler: Handler): this;
    private sameArr;
    private setCallback;
    private registeredArgs;
    static enumIndex: number;
    private createArg;
    private _submitted;
    submit(): void;
    isSubmitted(): boolean;
}
export declare enum CommandPermission {
    Everyone = 0,
    OP = 1,
    Console = 2
}
export declare function cmd(head: string, desc: string, perm?: 0 | 1 | 2): {
    setup: (executor: (register: (cmd: CommandExpr, handler: Handler) => void, registry: Registry) => void | Promise<void>) => void;
    getRegistry: () => Registry;
};
export {};
